import { SourceComponent } from '../sourceComponent';
import { DefaultSourceAdapter } from './defaultSourceAdapter';
/**
 * Handles types with partially decomposed content. This means that there will be 2+ files,
 * one being the parent (-meta.xml) and more being the "children" - these children make up one XML tag of the parent
 *
 * __Example Types__:
 *
 * DecomposeExternalServiceRegistrationBeta Preset
 *
 * __Example Structures__:
 *
 *```text
 * externalServiceRegistration/
 * ├── myFoo.externalServiceRegistration-meta.xml
 * ├── myFoo.yaml
 * ├── myFoo.json
 *```
 */
export declare class PartialDecomposedAdapter extends DefaultSourceAdapter {
    protected populate(trigger: string, component?: SourceComponent): SourceComponent;
}
